summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--NEWS4
-rw-r--r--THANKS.in1
-rw-r--r--src/ln.c14
-rwxr-xr-xtests/ln/sf-1.sh17
4 files changed, 33 insertions, 3 deletions
diff --git a/NEWS b/NEWS
index 699a7d3a1..88a41547e 100644
--- a/NEWS
+++ b/NEWS
@@ -14,6 +14,10 @@ GNU coreutils NEWS -*- outline -*-
when reading the SELinux context for a file.
[bug introduced in coreutils-8.22]
+ ln -sf now replaces symbolic links whose targets can't exist. Previously
+ it would display an error, requiring --no-dereference to avoid the issue.
+ [bug introduced in coreutils-5.3.0]
+
* Noteworthy changes in release 8.22 (2013-12-13) [stable]
diff --git a/THANKS.in b/THANKS.in
index 5b3e96ed2..fb7d6e084 100644
--- a/THANKS.in
+++ b/THANKS.in
@@ -341,6 +341,7 @@ Kaveh R. Ghazi ghazi@caip.rutgers.edu
Keith M. Briggs keith.briggs@bt.com
Keith Owens kaos@audio.apana.org.au
Keith Thompson kst@cts.com
+Ken Irving ken.irving@alaska.edu
Ken Pizzini kenp@halcyon.com
Kevin Mudrick kmudrick@healthmarketscience.com
Kirk Kelsey kirk.kelsey@0x4b.net
diff --git a/src/ln.c b/src/ln.c
index b4903620b..aab9cf2fa 100644
--- a/src/ln.c
+++ b/src/ln.c
@@ -103,8 +103,18 @@ static struct option const long_options[] =
{NULL, 0, NULL, 0}
};
+/* Return true when the passed ERR implies
+ that a file does not or could not exist. */
+
+static bool
+errno_nonexisting (int err)
+{
+ return err == ENOENT || err == ENAMETOOLONG || err == ENOTDIR || err == ELOOP;
+}
+
+
/* FILE is the last operand of this command. Return true if FILE is a
- directory. But report an error there is a problem accessing FILE,
+ directory. But report an error if there is a problem accessing FILE,
or if FILE does not exist but would have to refer to an existing
directory if it referred to anything at all. */
@@ -119,7 +129,7 @@ target_directory_operand (char const *file)
(dereference_dest_dir_symlinks ? stat (file, &st) : lstat (file, &st));
int err = (stat_result == 0 ? 0 : errno);
bool is_a_dir = !err && S_ISDIR (st.st_mode);
- if (err && err != ENOENT)
+ if (err && ! errno_nonexisting (errno))
error (EXIT_FAILURE, err, _("failed to access %s"), quote (file));
if (is_a_dir < looks_like_a_dir)
error (EXIT_FAILURE, err, _("target %s is not a directory"), quote (file));
diff --git a/tests/ln/sf-1.sh b/tests/ln/sf-1.sh
index 3f4f8f1ae..17e67a9fb 100755
--- a/tests/ln/sf-1.sh
+++ b/tests/ln/sf-1.sh
@@ -20,12 +20,27 @@
print_ver_ ln
echo foo > a || framework_failure_
-ln -s . b || framework_failure_
+# Check that a target directory of '.' is supported
+# and that indirectly specifying the same target and link name
+# through that is detected.
+ln -s . b || framework_failure_
ln -sf a b > err 2>&1 && fail=1
case $(cat err) in
*'are the same file') ;;
*) fail=1 ;;
esac
+# Ensure we replace symlinks that don't or can't link to an existing target.
+# coreutils-8.22 would fail to replace {ENOTDIR,ELOOP,ENAMETOOLONG}_link below.
+name_max_plus1=$(expr $(stat -f -c %l .) + 1)
+test $name_max_plus1 -gt 1 || skip_ 'Error determining NAME_MAX'
+long_name=$(printf '%0*d' $name_max_plus1 0)
+for f in '' f; do
+ ln -s$f missing ENOENT_link || fail=1
+ ln -s$f a/b ENOTDIR_link || fail=1
+ ln -s$f ELOOP_link ELOOP_link || fail=1
+ ln -s$f "$long_name" ENAMETOOLONG_link || fail=1
+done
+
Exit $fail